<?php

/*
 * 05.12.19 - Webbax - Tuto 65
 * Export compta
 */

include(dirname(__FILE__).'/../../config/config.inc.php');

$token = Tools::getValue('token');
$code = Tools::getValue('code');

if($token=='1234'){
        
        $file_csv = array();
        $Context = Context::getContext();
    
        $date_start = Tools::getValue('date_start');
        if(empty($date_start)){
            $date_start=date('Y-01-01');
        }else{
            $date_start = Tools::getValue('date_start');    
        }
        
        $date_end = Tools::getValue('date_end');
        if(empty($date_end)){
            $date_end=date('Y-12-31');         
        }else{
            $date_end = Tools::getValue('date_end');
        }
                
        $date_start = $date_start.' 00:00:00';
        $date_end = $date_end.' 23:59:59';
        $export_type = Tools::getValue('export_type');
        $fields_no = Tools::getValue('fields_no');
        $address_choice = Tools::getValue('address_choice');

        // parcours le détail des commandes
        $id_order_state = Tools::getValue('id_order_state');
        if(!empty($id_order_state)){
            $AND = 'AND o.`current_state`="'.pSQL($id_order_state).'"';
        }else{
            $AND = '';
        }
        $orders_detail = Db::getInstance()->ExecuteS('SELECT * FROM `'._DB_PREFIX_.'order_detail` od
                                                      LEFT JOIN `'._DB_PREFIX_.'orders` o ON (o.`id_order` = od.`id_order`)
                                                      WHERE `date_add` >= "'.pSQL($date_start).'"
                                                      AND `date_add` <= "'.pSQL($date_end).'"
                                                      AND o.`id_shop`="'.pSQL($Context->shop->id).'" '.
                                                      $AND);
        foreach($orders_detail as $k => $order_detail){

            $Order = new Order($order_detail['id_order']);
            $Customer = new Customer($Order->id_customer);

            if(Customer::customerIdExistsStatic($Customer->id) && $Customer->validateFields(false)){

                $f_no = array();
                
                // si la ligne de détail n'est pas valide, on passe à la suivante
                if(!$Order->validateFields(false)){continue;}
                $order = $Order->getFields();

                $f_no[] = $order_detail['id_order'];
                $f_no[] = $Order->reference;
                $f_no[] = date("d.m.Y", strtotime($order['date_add']));
                // info client
                $customer = $Customer->getFields();
                if($customer['id_gender']==1){$gender='Monsieur';}else{$gender='Madame';}
                // info adresse
                if($address_choice=='delivery'){
                    $id_address = $order['id_address_delivery'];
                }else{
                    $id_address = $order['id_address_invoice'];
                }
                $Address = new Address($id_address);
                if(!empty($id_address) && $Address->validateFields(false)){
                    $address = $Address->getFields();
                }
                $f_no[] = @$address['firstname'];
                $f_no[] = @$address['lastname'];
                    $country = Country::getNameById($order['id_lang'],@$address['id_country']);
                if($customer['newsletter']){
                    $newsletter = 'Oui';
                }else{
                    $newsletter = 'Non';
                }
                $f_no[] = $newsletter;
                $Group = new Group($customer['id_default_group']);
                $group = $Group->name[$order['id_lang']];
                $f_no[] = $order_detail['product_quantity'];
                $f_no[] = $order_detail['product_name'];
                $f_no[] = $order_detail['unit_price_tax_incl'];
                $id_tax = Db::getInstance()->getValue('SELECT `id_tax` 
                                                       FROM `'._DB_PREFIX_.'order_detail_tax` 
                                                       WHERE `id_order_detail` = "'.pSQL($order_detail['id_order_detail']).'"
                                                      ');
                $Tax = new Tax($id_tax);
                $f_no[] = $Tax->rate;

                // récupère l'emplacement du produit + prix achat
                $id_product = $order_detail['product_id'];
                // simple
                if(empty($order_detail['product_attribute_id'])){
                    $product = Db::getInstance()->getRow('SELECT p.`location`, ps.`wholesale_price` 
                                                          FROM `'._DB_PREFIX_.'product` p
                                                          LEFT JOIN `'._DB_PREFIX_.'product_shop` ps ON p.`id_product`=ps.`id_product`
                                                          WHERE p.`id_product`="'.pSQL($id_product).'"
                                                          AND `id_shop`="'.pSQL($Context->shop->id).'"');
                    $location = $product['location'];
                    $wholesale_price = $product['wholesale_price'];
                // déclinaison
                }else{
                    $id_product_attribute = $order_detail['product_attribute_id'];
                    $productDecl = Db::getInstance()->getRow('SELECT pa.`location`, pas.`wholesale_price` 
                                                              FROM `'._DB_PREFIX_.'product_attribute` pa
                                                              LEFT JOIN `'._DB_PREFIX_.'product_attribute_shop` pas ON pa.`id_product_attribute`=pas.`id_product_attribute`
                                                              WHERE pa.`id_product`="'.pSQL($id_product).'" 
                                                              AND pa.`id_product_attribute`="'.pSQL($id_product_attribute).'"
                                                              AND `id_shop`="'.pSQL($Context->shop->id).'"');
                    $location = $productDecl['location'];
                    $wholesale_price = $productDecl['wholesale_price'];
                }

                $f_no[] = $wholesale_price;
                $f_no[] = $order['total_discounts'];
                $f_no[] = $order_detail['reduction_amount_tax_incl'];
                $f_no[] = $order_detail['reduction_amount_tax_excl'];
                $f_no[] = $order['total_paid'];
                $f_no[] = $order['total_paid_real'];
                $f_no[] = $order['total_shipping'];
                $currency = new Currency($order['id_currency']);
                $f_no[] = $currency->iso_code;
                $f_no[] = $order['payment'];
                $f_no[] = $order['invoice_number'];
                $f_no[] = $order['delivery_number'];
                if($order['id_carrier']>0){
                    $Carrier = new Carrier($order['id_carrier']);
                    $carrier = $Carrier->getFields();
                    $carrier_name = $carrier['name'];
                }else{
                    $carrier_name = '';
                }
                $f_no[] = $carrier_name;
                $Language = new Language($order['id_lang']);
                if(!$Language->validateFields(false)){
                   $Language = new Language(Configuration::get('PS_LANG_DEFAULT'));
                }
                $language = $Language->getFields();
                $f_no[] = $language['name'];
                $cookie = $Context->cookie;
                $Product = new Product($id_product);
                $Category = new Category($Product->id_category_default,$cookie->id_lang);
                $OrderState = new OrderState($order['current_state']);
                $f_no[] = $OrderState->name[$Context->cookie->id_lang];
                
                if($k==0){
                    $file_csv[] = array('id_order','reference','date','firstname');
                }
                
                $file_csv[] = $f_no; // ajoute nouvelle ligne triée au fichier
                
            } // end if customer exist + valid
        }
       
        if(!empty($file_csv)){
            
            echo '<a href="'.Tools::getHttpHost(true).__PS_BASE_URI__.'modules/scripts/compta.csv" target="_blank">'.Tools::getHttpHost(true).__PS_BASE_URI__.'modules/scripts/compta.csv</a><br/>';
            
            foreach($file_csv as $line){
                foreach($line as $field){
                    echo $field.';';
                }
                echo "<br/>";
            }

            $fp = fopen('compta.csv', 'w');
            foreach ($file_csv as $fields) {
                fputcsv($fp,$fields,';');
            }
            fclose($fp);

            exit();
        
        }else{
            
            echo 'Aucun élément';
            
        }
        
}else{
    die('Error Token');
}

?>